set_form_variables
set required_variables [list {submaintainer_path "the error path for this submaintainer"}]

set error_message ""
foreach required_var $required_variables {
    if {[subst \$[lindex $required_var 0]]==""} {
	append error_message "<li>You failed to enter [lindex $required_var 1].  Please go back and remedy this."
    }
}

if {![philg_email_valid_p $submaintainers_email]} {
    append error_message "<li>The email you gave me ($submaintainers_email) does not seem to be valid."
}

if {$error_message!=""} {
    tcollins_SendError [watchdog_error_page] $error_message
    return
}

set new_submaintainer_pair [list $submaintainer_path $submaintainers_email]
set server_data [watchdog_access_registry_for_server $server_name]
set submaintainers_list [lindex $server_data 5]
#make sure the pattern isn't already there
if {[lsearch -exact $submaintainers_list $new_submaintainer_pair]!=-1} {
    tcollins_SendError [watchdog_error_page] "This pattern is already marked for this submaintainer on this server."
    return
}

lappend submaintainers_list $new_submaintainer_pair

set server_data [lreplace $server_data 5 5 $submaintainers_list]
if [catch {watchdog_update_registry_for_server $server_name $server_data} errmsg] {
    tcollins_SendError [watchdog_error_page] "Error while updating the registry: $errmsg"
    return
}

#return the user a confirmation
ReturnHeaders
ns_write "
[watchdog_headers]
<br><h2>Submaintainer $submaintainers_email added for $submaintainer_path for $server_name</h2>
<p>
You may now continue to <a href=\"server-index.tcl?server_name=[ns_urlencode $server_name]\">administer your watchdog's parameters</a>.
<p>
[watchdog_footers]
"

