ReturnHeaders
ns_write "
[watchdog_headers]
<h2>Watchdog Documentation</h2>
<hr>
<ul>
<li><b>What it does:</b><br>
	<ol>
	<li>Monitors various error logs for AOLserver installations, sending the list of errors it finds in the logs to the maintainer.
	<li>Allows for pattern-matching for error-report exclusion, e.g. &quot;I don't care about these sigwait() errors, so don't tell me about them&quot;
	<li>Allows for sub-maintainers who will receive reports of errors only on particular subdirs, i.e. joe@service.com maintains the overall website, but any errors occuring in  /frank should notify frank@service.com.
	<li>Keeps track of what has already been read, to prevent repeat notification of the same errors, so long as the server has not gone down.
	</ol>

<li><b>How it does it:</b><br>
	<ul>
	<li><b>Configuration of servers:</b><br>
		<ol>
		<li>Servers are added with <a href=\"../add-server-1.tcl\">add-server-1.tcl</a>.  This form stores the basic information in a flat registry file , named [watchdog_registry_file] on this installation.
		<li>Each line of the registry represents all the configuration data for one server watchdog monitors.  This line is a string representation of a tcl list, with the following format:<p>
<kbd>
{server_name maintainer server_log server_error_log {ignore_patterns list} {{path-patterns sub-maintainers-email}{more path/submaintainer lists}...}}
</kbd>
<p>
		<li>Once added, servers are maintained from \"/server-index.tcl?server_name=<i>server-name</i>\".  These pages allow the editing of parameters and the addition/deletion of patterns to ignore and submaintainers.
		</ol>
	<li><b>Parsing of the error logs</b><br>
		<ol>
		<li>For each server, watchdog shares a global variable named <i>server_name</i>_error_file_marker.  The value of this variable is the number of bytes read from the current log.  If this value is greater than the current log length, watchdog assumes a new error log file is in place and will start from 0 bytes.
		<li>Watchdog opens the error log and seeks to where it left off.  It then begins to read one line at a time, checking against this regexp:<p>
<kbd>
\[regexp {^(\\\[\[^\]\]*\\\])(\\\[\[^\]\]*\\\])(\\\[\[^\]\]*\\\]) Error: (.*)\$}  \$next_line match date process server_name error_string\]
</kbd>
<p>
		If successful, watchdog will then check \$error_string against the patterns to ignore, and if it is not meant to be ignored, will append it to a list of errors to be emailed to the maintainer.  Watchdog then checks \$error_string against the patterns for the submaintainers, and will append any relevant errors to a list for each submaintainer.
		<li>After completely parsing the error log, watchdog will send email to any maintainer or submaintainer whose list of error messages is non-null.
                <li>After a certain number of runs, Watchdog will send a summary email to let the maintainers know that it is still running.
                <li><em>nb: Because watchdog keeps track of its place in the various error logs and the number of runs it has engaged in shared variables, rstarting the server will obliterate this information.</em>
		</ol>
	</ul>
<li><b>Setup:</b><br>
	<ol>
	<li>You can install watchdog on its own server, or on a pre-existing one.
	<li>Edit the parameters in defs.tcl to conform to your installation.
	</ol> 
</ul>
<hr>
[mailto tcollins@arsdigita.com]
</body>
</html>
"
