set_form_variables
set required_variables [list {new_server_name "Server name"} {server_log "Server log"} {server_error_log "Server Error Log"} {maintainers_email "any email addresses"}]

set error_message ""
foreach required_var $required_variables {
    if {[subst \$[lindex $required_var 0]]==""} {
	append error_message "<li>You failed to enter [lindex $required_var 1].  Please go back and remedy this."
    }
}

set maintainers_email [string trim [tcollins_dectrlM $maintainers_email]]
set maintainers_list [split $maintainers_email \n]
foreach email $maintainers_list {
    if {![philg_email_valid_p $email]} {
	append error_message "<li>The email \"$email\" does not seem to be valid."
    }
}

if {![file exists $server_log]} {
    append error_message "<li>The server log you specified ($server_log) does not exist!"
}

if {![file exists $server_error_log]} {
    append error_message "<li>The server error log you specified ($server_error_log) does not exist!"
}

if {$error_message!=""} {
    tcollins_SendError [watchdog_error_page] $error_message
    return
}

#now load in the old data and replace
set server_data [watchdog_access_registry_for_server $server_name]
set server_data [lreplace $server_data 0 3 $new_server_name $maintainers_list $server_log $server_error_log]

if [catch {watchdog_update_registry_for_server $server_name $server_data} errmsg] {
    tcollins_SendError [watchdog_error_page] "Error while updating the registry: $errmsg"
    return
}

set server_name $new_server_name
#now send confirmation to the user
ReturnHeaders
ns_write "
[watchdog_headers]
<h2>Server $server_name Edited</h2>
<p>
You may now <a href=\"server-index.tcl?server_name=[ns_urlencode $server_name]\">administer your watchdog's parameters</a>.
<p>
[watchdog_footers]
"
