set_form_variables
set required_variables [list {pattern_to_ignore "the pattern to ignore"}]

set error_message ""
foreach required_var $required_variables {
    if {[subst \$[lindex $required_var 0]]==""} {
	append error_message "<li>You failed to enter [lindex $required_var 1].  Please go back and remedy this."
    }
}

if {$error_message!=""} {
    tcollins_SendError [watchdog_error_page] $error_message
    return
}

set server_data [watchdog_access_registry_for_server $server_name]
set error_matching_list [lindex $server_data 4]
#make sure the pattern isn't already there
if {[lsearch -exact $error_matching_list $pattern_to_ignore]!=-1} {
    tcollins_SendError [watchdog_error_page] "This pattern is already being ignored for this server."
    return
}
lappend error_matching_list $pattern_to_ignore

set server_data [lreplace $server_data 4 4 $error_matching_list]
if [catch {watchdog_update_registry_for_server $server_name $server_data} errmsg] {
    tcollins_SendError [watchdog_error_page] "Error while updating the registry: $errmsg"
    return
}

#return the user a confirmation
ReturnHeaders
ns_write "
[watchdog_headers]
<br><h2>Pattern to Ignore Added for $server_name</h2>
<p>
You may now continue to <a href=\"server-index.tcl?server_name=[ns_urlencode $server_name]\">administer your watchdog's parameters</a>.
<p>
[watchdog_footers]
"

