proc tcollins_SendTemplate {htmlpage} {
    set command_block "
    set FILEIN \[open $htmlpage r\]
    set template_to_send \[read \$FILEIN\]
    close \$FILEIN
    
    
    while {\[regexp {<!--var:\[^-\]+-->} \$template_to_send\]==1} {

	#protect javascript
	regsub -all {\\\$} \$template_to_send \"\\\\\\\$\" template_to_send
	regsub -all {\\\[} \$template_to_send \"\\\\\\\[\" template_to_send
	regsub -all {\\\]} \$template_to_send \"\\\\\\\]\" template_to_send

	regsub -all {<!--var:(\[^-\]+)-->} \$template_to_send \$\\\{\\\\1\\\} template_to_send
	set template_to_send \[subst \$template_to_send\]
    }

    ns_return 200 text/html \$template_to_send"
    

    uplevel $command_block
}

#here's a version for when you've already returned the headers
proc tcollins_SendTemplate_after_headers {htmlpage} {
    set command_block "
    set FILEIN \[open $htmlpage r\]
    set template_to_send \[read \$FILEIN\]
    close \$FILEIN
    
    
    while {\[regexp {<!--var:\[^-\]+-->} \$template_to_send\]==1} {

	#protect javascript
	regsub -all {\\\[} \$template_to_send \"\\\\\\\[\" template_to_send
	regsub -all {\\\]} \$template_to_send \"\\\\\\\]\" template_to_send

	regsub -all {<!--var:(\[^-\]+)-->} \$template_to_send \$\\\{\\\\1\\\} template_to_send
	set template_to_send \[subst \$template_to_send\]
    }

    ns_write  \$template_to_send"
    

    uplevel $command_block
}

proc tcollins_SendError {template error_message} {
    set FILEIN [open $template r]
    set html [read $FILEIN]
    close $FILEIN

    regsub -all {\[} $html \\\[ html
    regsub -all {\]} $html \\\] html

    regsub -all {<!--var:([^-]*)-->} $html $\{\\1\} html

    set html [subst $html]
    ns_return 200 text/html $html
}

proc tcollins_SendTemplateString {htmlstring} {
    #since the tcl interpreter will
    #evaluate $htmlstring as a tcl expression
    #in the command block, we have to protect it first.

    regsub -all {"} $htmlstring {\\"} htmlstring
    regsub -all {\[} $htmlstring {\\\[} htmlstring
    regsub -all {\]} $htmlstring {\\\]} htmlstring
    regsub -all {\$} $htmlstring {\\\$} htmlstring

    set command_block "
    set template_to_send \"$htmlstring\"
    while {\[regexp {<!--var:\[^-\]+-->} \$template_to_send\]==1} {

	#protect javascript
	regsub -all {\\\[} \$template_to_send \"\\\\\\\[\" template_to_send
	regsub -all {\\\]} \$template_to_send \"\\\\\\\]\" template_to_send

	regsub -all {<!--var:(\[^-\]+)-->} \$template_to_send \$\\\{\\\\1\\\} template_to_send
	set template_to_send \[subst \$template_to_send\]
    }

    ns_return 200 text/html \$template_to_send"
    

    uplevel $command_block
}

proc tcollins_mailto {address} {
    return "<a href=\"mailto:$address\">$address</a>"
}

proc tcollins_href {URL} {
    #returns linkef URL if URL non-null, else returns empty string
    if {$URL==""} {
	return
    }
    return "<A href=\"$URL\">$URL</a>"
}

proc tcollins_readline {fileId upvar_to_set} {
    #this returns the number of bytes read
    set line_in ""
    set bytes_read 0
    set char [read $fileId 1]
    set special_chars [list \] \[ \\ \$ \"]
    while {![eof $fileId]} {
	incr bytes_read
	if {[string compare $char \n]==0} {
	    uplevel "set $upvar_to_set \"[tcollins_backslash $line_in $special_chars]\""
	    return $bytes_read
	}
	append line_in $char
	set char [read $fileId 1]
    }
    if {$line_in!=""} {
	uplevel "set $upvar_to_set \"[tcollins_backslash $line_in $special_chars]\""
	return $bytes_read
    } else {
	return $bytes_read
    }
}

proc tcollins_backslash {string character_list {num_backslashes 1}} {
    set backslashes ""
    for {set i 0} {$i<$num_backslashes} {incr i} {
	append backslashes "\\\\"
    }
    set pattern [join $character_list "|\\"]
    set pattern "(\\$pattern)"
    regsub -all "$pattern" $string ${backslashes}& string_to_return
    return $string_to_return
}

proc tcollins_htmlify {string} {
    regsub -all "<" $string {\&lt;} string
    regsub -all ">" $string {\&gt;} string
    regsub -all "\"" $string {\&quot;} string
    regsub -all "\n" $string "<br>\n" string
    return $string
}

proc tcollins_dectrlM {string} {
    regsub -all {
} $string {} string
    return $string
}
